﻿using System;
using System.IO;
using System.IO.IsolatedStorage;
using System.Linq;
using System.Net.Mail;
using System.Runtime.InteropServices;
using System.Text;

namespace CV6
{
    class Program
    {
        // Directly copied from pinvoke.net, that's all :)
        enum SYMBOLIC_LINK_FLAG
        {
            File = 0,
            Directory = 1
        }

        [DllImport("kernel32.dll")]
        [return: MarshalAs(System.Runtime.InteropServices.UnmanagedType.I1)]
        static extern bool CreateSymbolicLink(string lpSymlinkFileName, string lpTargetFileName, SYMBOLIC_LINK_FLAG dwFlags);

        const string Dir = @"C:\ATNET";
        const string FileName = "log.txt";

        static IsolatedStorageFile file = IsolatedStorageFile.GetUserStoreForAssembly();

        static void Main(string[] args)
        {
            FileSystemWatcher watcher = new FileSystemWatcher(Dir);
            watcher.IncludeSubdirectories = true;

            watcher.Renamed += OnRenamed;
            watcher.Created += OnChanged;
            watcher.Deleted += OnChanged;

            watcher.EnableRaisingEvents = true;

            while (Console.ReadKey().KeyChar != 'q') ;

            // You need Administrator privileges to correct exetute this method!
            CreateSymbolicLink(@"C:\Users\myLink", @"C:\Windows\assembly", SYMBOLIC_LINK_FLAG.Directory);
        }

        static void OnChanged(object sender, FileSystemEventArgs e)
        {
            string str = String.Format("{0}: {1}", e.ChangeType, e.FullPath);
            Console.WriteLine(str);
            LogToFile(str);

            if (e.ChangeType == WatcherChangeTypes.Created)
            {
                DirectoryInfo dir = new DirectoryInfo(Dir);
                FileInfo[] files = dir.GetFiles("*.*", SearchOption.AllDirectories);
                long size = files.Sum(f => f.Length);

                if (size > 12)
                {
                    var result = from f in files
                                 where f.Length > 4
                                 orderby f.Length descending
                                 select f.FullName;

                    using (IsolatedStorageFileStream stream = new IsolatedStorageFileStream(FileName, FileMode.Open, FileAccess.Read, file))
                    using (SmtpClient client = new SmtpClient("smtp.vsb.cz"))
                    using (MailMessage mess = new MailMessage("lumir.kojecky@vsb.cz", "lumir.kojecky@vsb.cz"))
                    using (Attachment att = new Attachment(stream, "MyLogFile.txt"))
                    {
                        mess.Subject = "Warning";
                        StringBuilder body = new StringBuilder();

                        foreach (string fileName in result)
                        {
                            body.AppendLine(fileName);
                        }

                        mess.Body = body.ToString();
                        mess.Attachments.Add(att);
                        client.Send(mess);
                    }
                }
            }
        }

        static void OnRenamed(object sender, RenamedEventArgs e)
        {
            string str = String.Format("Rename: {0} -> {1}", e.OldFullPath, e.FullPath);
            Console.WriteLine(str);
            LogToFile(str);
        }

        static void LogToFile(string str)
        {
            using (IsolatedStorageFileStream stream = new IsolatedStorageFileStream(FileName, FileMode.Append, FileAccess.Write, file))
            using (StreamWriter writer = new StreamWriter(stream))
            {
                writer.WriteLine(str);
            }
        }
    }
}
